;Self-seed? -> Plus de possibilit d'archivage... :( -> on laisse tomber, sauf
;              si j'arrive  trouver un seed en RAM / ROM
;Scrolling diffrentiel? -> Ola... on va attendre un peu avant de s'y mettre...
;Double-Click? -> mettre en relation une nouvelle variable = tstb ...
;Taille variable? -> page de prsentation -> OK!
;Nombre de mines variable?!!! -> page de prsentation -> OK!
;Touches variables? -> mmmoui... aprs le scroll. diff. :)
        include "doorsos.h"
        include "userlib.h"
        include "graphlib.h"
        xdef    _ti89
        xdef    _comment
        xdef    _main

ord_0   equ     48          ;N du charactre "0" = ord("0)
maxvert equ     12          ;Hauteur maximale supporte
maxhor  equ     20          ;Largeur maximale tolre

_main:
        jsr     graphlib::clr_scr    ;On efface l'cran
        bsr     pass_to_4            ;On passe en mode 4 niveaux de gris
main_menu:
;********************************
;*** Affichage du titre 10*46 ***
;********************************
	 SetFont #1
        move.w  #1,graphlib::choosescreen
        bsr     clr_scr
        lea        titre(pc),a2      ;a2 pointe sur le 1er grob du titre
        lea        10*46(a2),a3      ;a3 sur le 2me
        move.l     graphlib::plane0,a0   ;a0 pointe sur l'adresse 1 de l'cran
        move.l     graphlib::plane1,a1   ;a1 sur la 2me
        lea        5(a1),a1              ;On centre le titre
        lea        5(a0),a0              ;idem
        move.w     #44,d0                ;d0=nb de ligne
loop_aff_titre_1:
        move.w     #9,d1                 ;d0=nb d'octets <=> colonnes
loop_aff_titre_2:
        move.b     (a2)+,(a0)+           ;On superpose
        move.b     (a3)+,(a1)+           ;les deux grobs du titre
        dbra       d1,loop_aff_titre_2   ;octet suivant
        lea        20(a1),a1             ;retour a
        lea        20(a0),a0             ;la ligne
        dbra       d0,loop_aff_titre_1   ;ligne suivante

        WriteStr   #40,#55,#4,strmine    ;Affiche
        WriteStr   #40,#64,#4,strhor     :les
        WriteStr   #40,#73,#4,strvert    ;options

main_loop:
        move.l     nb2,d0                ;affiche le nb de mines
        move.w     #55,d1                ;ligne n55
        bsr        aff2c
        move.l     hor2,d0               ;nb de lignes
        move.b     #64,d1
        bsr        aff2c
        move.l     vert2,d0              ;nb de colonnes
        move.b     #73,d1
        bsr        aff2c

        jsr        userlib::idle_loop    ;attend une touche
        cmp.w      #$108,d0              ;[ESC]?
        beq        fin                   ;oui -> sortie
        cmp.w      #$2D,d0               ;[-]?
        bne        main_nominus          ;non -> suivant
        cmp.l      #1,nb2                ;nb de mines courant = 1 ?
        beq        main_loop             ;oui -> aucun changement
        sub.l      #1,nb2                ;nb de mine = nb de mine - 1
        bra        main_loop             ;retour boucle
main_nominus:
        cmp.w      #$2B,d0               ;[+]?
        bne        main_noplus           ;non -> suivant
        move.l     hor2,d0
        move.l     vert2,d1
        mulu       d1,d0
        sub.w      #1,d0                 ;d0 = nb max de mines
        cmp.l      nb2,d0                ;nb de mine = nb max ?
        beq        main_loop             ;oui -> aucun changement
        cmp.l      #99,nb2               ;99 mines ?
        beq        main_loop             ;oui -> aucun changement
        add.l      #1,nb2                ;nb de mine = nb de mine + 1
        bra        main_loop             ;retour boucle
main_noplus:
        cmp.w      #$151,d0              ;[HAUT] ?
        bne        main_noup             ;non -> suivant
        cmp.l      #maxvert,vert2        ;nb de lignes = max ?
        beq        main_loop             ;oui -> sans changement
        add.l      #1,vert2              ;nb de ligne + 1
        bra        main_loop             ;retour boucle
main_noup:
        cmp.w      #$154,d0              ;[BAS] ?
        bne        main_nodown           ;non -> suivant
        cmp.l      #5,vert2              ;5 lignes ? ( = minimum )
        beq        main_loop             ;oui -> sans changement
        sub.l      #1,vert2              ;nb de ligne - 1
        bra        main_loop             ;retour boucle
main_nodown:
        cmp.w      #$158,d0              ;[DROITE] ?
        bne        main_noright          ;non -> suivant
        cmp.l      #maxhor,hor2          ;nb de colonnes = max ?
        beq        main_loop             ;oui -> aucun changement
        add.l      #1,hor2               ;nb de colonne + 1
        bra        main_loop             ;retour boucle
main_noright:
        cmp.w      #$152,d0              ;[GAUCHE] ?
        bne        main_noleft           ;non -> suivant
        cmp.l      #5,hor2               ;5 colonnes ? ( = minimum )
        beq        main_loop             ;oui -> sans changement
        sub.l      #1,hor2               ;nb de colonnes - 1
        bra        main_loop             ;retour boucle
main_noleft:
        cmp.w      #$D,d0                ;[ENTER] ?
        bne        main_loop             ;non -> retour boucle

        move.l     nb2,nb                ;toutes les valeurs
        sub.l      #1,nb                 ;sont dcrmentes une fois
        move.l     hor2,hor
        sub.l      #1,hor
        move.l     vert2,vert
        sub.l      #1,vert

        bsr        clr_scr               ;effcement de l'cran

        lea        pos(pc),a0            ;Initiation
        clr.l      (a0)+                 ;des
        clr.l      (a0)+                 ;variables

        lea     tab(pc),a0               ;meme du tableau
        move.w  #239,d0
loop_new_tab:
        clr.b   (a0)+
        dbra.w  d0,loop_new_tab

        move.l  graphlib::plane0,a0      ;Affichage du tableau vide
        move.l  graphlib::plane1,a2
        move.l  vert,d7                  ;nb de lignes
loop_tab_1:
        move.l  hor,d6                   ;nb de colonnes
loop_tab_2:
        lea     bloc(pc),a1              ;a1 pointe sur le grob
        bsr     aff0                     ;affichage en plane0
        bsr     aff2                     ;affichage en plane1
        lea     1(a0),a0                 ;emplacement suivant
        lea     1(a2),a2                 ;(sur l'cran)
        dbra    d6,loop_tab_2            ;colonne suivante
        move.l  #29,d6                   ;dcalage
        sub.l   hor,d6                   ;de 30 - nb de colonnes
        adda.l  d6,a0
        adda.l  d6,a2
        adda.l  #30*7,a0                 ;plus 7
        adda.l  #30*7,a2                 ;lignes
        dbra    d7,loop_tab_1            ;ligne suivante

;***************************
;* Mise en place des mines *
;***************************
	 move.l  nb,d0				;
	 add.l	  #1,d0
	 move.l  d0,nbmr_aff			;initialisation du nombre de mines restantes  afficher
        clr.l   d7                       ;initialisation de d7.l
        move.l  hor2,d2
        move.l  vert2,d3                 ;mines poses alatoirement
        mulu    d3,d2                    ;(nb de colonnes) * (nb de lignes) possibilits
        lea     nb(pc),a0                ;nb de mines
        move.l  (a0)+,d7                 ;dans d7
        sub.l   d2,d7
        not.l   d7
        move.l  d7,(a0)                  ;emplacements libres dans nbreste
        sub.l   d2,d7
        not.l   d7                       ;d7 nb de possibilits
        clr.l   d1
put_mine:
        move.w  d2,d0
        jsr     userlib::random          ;valeur alatoire dans d0
        lea     tab(pc),a0
        move.w  d0,d1
        adda.l  d1,a0
        cmp.b   #1,(a0)                  ;mine dj pose ?
        beq     put_mine                 ;oui -> retour sans dcrmentation
        move.b  #1,(a0)                  ;mine pose!
        dbra.w  d7,put_mine              ;dcrmentation

	 SetFont #0
	move.b	#'*',char2
	WriteStr   #0,#95,#4,char2


;*******
;* Jeu *
;*******

jeu:
        bsr     affno                   ;Inverse la premire case
;        lea     newpart(pc),a0
;        move.b  #1,(a0)
	 bsr	  aff_nbmr			;Affichage du nombre de mines restant  dminer

get_key:
        lea     nbreste(pc),a0          ;Teste le nombre de mines restantes
        tst.l   (a0)                 ;a plus ?
        beq     win                     ;oui -> bravo!
        jsr     userlib::idle_loop      ;Tests des touches
        cmp.w   #$108,d0                ;[ESC] ?
        beq     main_menu               ;oui -> fin
        cmp.w   #$152,d0			;[<-] ?
        bne     noleft			;non -> autres test
        lea     pos(pc),a0			;On efface le surlignage
        bsr     affno
        tst.l   (a0)				;on est au bout?
        beq     nototleft
        sub.l   #1,(a0)			;si non, on retire 1
        bsr     affno			;on raffiche le surlignage
        bra     nosecure			;on repart
nototleft:
        move.l  hor,(a0)			;x = nbmax de colonnes
        bsr     affno			;on raffiche le surlignage
        bra     nosecure			;on repart
noleft:
        cmp.w   #$158,d0			;meme chose avec droite
        bne     noright
        bsr     affno
        lea     pos(pc),a0
        move.l  (a0),d0
        cmp.l   hor,d0
        beq     nototright
        add.l   #1,(a0)
        bsr     affno
        bra     nosecure
nototright:
        clr.l   (a0)
        bsr     affno
        bra     nosecure
noright:
        cmp.w   #$151,d0			;meme chose avec haut
        bne     noup
        bsr     affno
        lea     pos(pc),a0
        lea     4(a0),a0
        tst.l   (a0)
        beq     nototup
        sub.l   #1,(a0)
        bsr     affno
        bra     nosecure
nototup:
        move.l  vert,(a0)
        bsr     affno
        bra     nosecure
noup:
        cmp.w   #$154,d0			;meme chose avec bas
        bne     nodown
        bsr     affno
        lea     pos(pc),a0
        lea     4(a0),a0
        move.l  (a0),d0
        cmp.l   vert,d0
        beq     nototdown
        add.l   #1,(a0)
        bsr     affno
        bra     nosecure
nototdown:
        clr.l   (a0)
        bsr     affno
        bra     nosecure
nodown:
        cmp.w   #$D,d0			;teste [ENTER]
        bne     noenter			;sinon, test suivant
        bsr     get_pers			;Qu'y a t il a cet endroit?
        cmp.b   #1,d5			;Une mine non protge?
        beq     death			;alors perdu
;        cmp.b   #2,d5
;        beq     enter_autour
        lea     pos(pc),a0			;coordonnes du dmineur
        move.l  (a0)+,d1			;d1 = 
        move.l  (a0),d0			;d0 = 
        bsr     doenter			;appel de la routine
        bra     get_key			;on repart
noenter:
        cmp.w   #$002B,d0			;teste [+]
        bne     nosecure			;sinon, test suivant
        bsr     get_pers			;Qu'y a t il a cet endroit?
        cmp.b   #2,d5			;Une case dcouverte?
        beq     nosecure			;Si oui, test suivant
	 sub.l	  #1,nbmr_aff			;Nb de mine  dminer - 1
        bchg.b  #2,d5			;On change le bbit #2 caractristique
        bsr     put_pers			;On remplace la valeur de la case
        move.b  #$FF,d3			;d3 = -1
        btst.b  #2,d5			;Est-ce qu'on a mis un flag?
        bne     affsec			;sinon, c'est bon
        clr.b   d3				;d3 = 0
	 add.l	  #2,nbmr_aff			;On a enlev un flag -> on rajoute #1, mais on a dj enlev #1, donc on rajoute #2!
affsec:
        bsr     aff_sec			;Affiche le flag
	 bsr	  aff_nbmr			;Affiche le nombre de mines restant  dminer
nosecure:
        bra     get_key			;On repart!

fin:						;Label de fin
        clr.w   graphlib::choosescreen	;Screen par dfaut
        jsr     graphlib::gray2		;Retour en N&B
        rts					;Fin du programme

win:						;Label qd on a gagn
        move.l  graphlib::plane1,a0
	move.w	#750-1,d0
loop_eff_win:
	clr.l	(a0)+
	dbra	d0,loop_eff_win

        move.w  #4,-(a7)              ;color #4 : black on whithe
        pea     winstr(pc)            ;adress of the string
        move.w  #95,-(a7)             ;y coord
        move.w  #0,-(a7)              ;x coord
        jsr     doorsos::DrawStrXY    ;calls the ROM function
        lea     10(a7),a7             ;restores the stack
;        lea     newpart(pc),a0
;        clr.b   (a0)
        jsr     userlib::idle_loop		;Attend une touche
        bra     main_menu				;Fin du programme

death:						;Label qd on a perdu
	clr.w	d7
	move.w	#4,d0
	trap	#9
	move.b	(a0),d7
	sub.w	#1,d7
	move.b	d7,contrast
loop_down_ctr:
	jsr	doorsos::OSContrastDn
	bsr	small_pause
	dbra	d7,loop_down_ctr
        lea     tab(pc),a3			;on repasse toutes les cases pour montrer ou taient les bombes
        move.l  graphlib::plane0,a0	;a0 = screen 0
        move.l  graphlib::plane1,a2	;a1 = screen 1
        move.l  vert,d7			;d7 = valeur max verticale - 1
loop_death_1:
        move.l  hor,d6			;d6 = valeur max horizontale - 1
loop_death_2:
        cmp.b   #1,(a3)			;bombe non recouverte?
        bne     nobombe			;sinon, test suivant
        lea     bombe(pc),a1		;On affiche
        bsr     aff0				;une bombe
        bsr     aff2
        bra     nothingdeath		;fin des tests
nobombe:
        cmp.b   #4,(a3)			;Une case sans bombe protge?
        bne     nothingdeath		;sinon, fin des tests
        lea     notsprite(pc),a1		;On affiche
        bsr     aff0				;la croix
        bsr     aff2				;x
nothingdeath:
        lea     1(a0),a0			;On passe  l'octet suivant
        lea     1(a3),a3
        lea     1(a2),a2
        dbra.w  d6,loop_death_2		;boucle pour l'horizontale
        adda.l  #30*7,a0			;on saute 8 lignes
        move.l  #30,d0			;+ ce qu'il reste d'octets
        sub.l   hor2,d0			;pour aller au dbut de la ligne suivante
        adda.l  d0,a0
        adda.l  #30*7,a2
        adda.l  d0,a2
        dbra.w  d7,loop_death_1		;boucle pour la verticale
        move.w  #4,-(a7)                      ;color #4 : black on whithe
        pea     deathstr(pc)                  ;adress of the string
        move.w  #95,-(a7)                     ;y coord
        clr.w   -(a7)                ;x coord
        jsr     doorsos::DrawStrXY         ;calls the ROM function which draws a string in current font
        lea     10(a7),a7                  ;restores the stack
;        lea     newpart(pc),a0
;        clr.b   (a0)
	bsr	big_pause
	clr.w	d7
	move.b	contrast,d7
loop_up_ctr:
	jsr	doorsos::OSContrastUp
	bsr	small_pause
	dbra	d7,loop_up_ctr
	clr.w	doorsos::kb_globals+$1C
        jsr     userlib::idle_loop		;Attend une touche
        bra     main_menu			;Fin du programme

;****************************************************
;*** Affiche le nombre de mines restant  dminer ***
;****************************************************
aff_nbmr:
	move.w	#'  ',char1			;Efface le '-' qu'il pourrait y avoir
	WriteStr   #6,#95,#4,char1		;Efface
	move.l	nbmr_aff,d0			;d0 = nb de mines restant
	btst.b	#7,d0				;Positif?
	beq	aff_nbmr_normal		;Si oui, on n'affiche pas le '-'
	move.b	#'-',char2			;On crit un '-' devant
	movem.l d0,-(a7)			;On sauve d0
	WriteStr   #6,#95,#4,char2		;On crit le '-'
	movem.l (a7)+,d0			;On restaure d0
	not.l	d0				;On inverse d0
	add.l	#1,d0				;Et on lui ajoute #1 -> d0.nouveau = - d0.ancien
;	and.l	#$3F,d0			;
aff_nbmr_normal:				;On affiche le nb de mines
       divu       #10,d0			;On divise d0 par 10: le quotient est dans d0.w et le reste dans l'autre partie de d0
       add.b      #ord_0,d0			;Chiffre correspondant au quotient
       move.b     d0,char1			;1er caractre = quotient
       swap       d0				;d0.w = reste
       add.b      #ord_0,d0			;meme travail
       move.b     d0,char2			;dans le 2me caractre
       WriteStr   #11,#95,#4,char1		;On crit les nombres
       rts					;Retour ss prog.
	
;****************************************************
;*** Affiche deux chiffres - page de prsentation ***
;****************************************************
;d0.l=nombre, d1.w=ligne de l'cran
aff2c:
        divu       #10,d0			;Meme travail qu'au dessus
        add.b      #ord_0,d0
        move.b     d0,char1
        swap       d0
        add.b      #ord_0,d0
        move.b     d0,char2
        WriteStr   #94,d1,#4,char1
        rts

;************************************************
;*** Affichage & Effacement du curseur en xor ***
;************************************************
affno:
        movem.l d0-d2/a0-a1,-(a7)
        lea     pos(pc),a1		;a1 pointe sur la position du curseur
        move.l  (a1)+,d0		;d0 = 
        move.l  (a1)+,d1		;d1 = 
        lsl.l   #1,d1		;30 * d1
        move.l  d1,d2
        lsl.l   #4,d1
        sub.l   d2,d1
        lsl.l   #3,d1		;8 * d1
        add.l   d1,d0			;dcalage horizontal
        move.l  graphlib::plane0,a0	;a0 pointe sur plane0
        move.l  graphlib::plane1,a1	;a1 pointe sur plane1
        adda.l  d0,a0		;a0 pointe au bon endroit
        adda.l  d0,a1		;a1 aussi
        move.w  #7,d0		;8 boucles
loop_affno:
        not.b   (a1)			;On inverse
        lea     30(a1),a1		;Ligne suivante
        not.b   (a0)			;On inverse
        lea     30(a0),a0		;Ligne suivante
        dbra.w  d0,loop_affno	;Boucle
        movem.l (a7)+,d0-d2/a0-a1
        rts

aff0:
        movem.l d7/a0,-(a7)
        move.w  #7,d7
aff_loop:
        move.b  (a1)+,(a0)
        lea     30(a0),a0
        dbra.w  d7,aff_loop
        movem.l (a7)+,d7/a0
        rts

;*****************************************************
;*** Met a la position du curseur le contenu de d5 ***
;*****************************************************
put_pers:
        movem.l d0-d1/a0,-(a7)
        lea     pos(pc),a0
        move.l  (a0)+,d1	;charge d1
        move.l  (a0)+,d0	;et d0
        bsr     put_d5_in_tab_d0_d1
        movem.l (a7)+,d0-d1/a0
        rts

;**************************
;*** Affiche le drapeau ***
;**************************
aff_sec:
        movem.l d0,-(a7)
        lea     pos(pc),a0
        move.l  (a0)+,d1		;position du
        move.l  (a0),d0		;curseur
        bsr     affno		;inverse pour remettre normal
        lea     flag(pc),a1		;grob
        lea     bloc(pc),a3		;grob
        move.l  graphlib::plane0,a0	;a0 = screen0
        lsl.l   #1,d0
        move.l  d0,d2
        lsl.l   #4,d0
        sub.l   d2,d0
        lsl.l   #3,d0		;30 * 8 * d0
        add.l   d1,d0		;+ horizontal
        adda.l  d0,a0		;dcalge
        adda.l  d0,a2		;des crans
        move.w  #7,d7		;nb de boucles
loop_secure:
        move.b  (a1)+,(a0)		;On affiche
        and.b   d3,(a0)		;Mask
        move.b  (a3)+,d4		;On affiche
        or.b    d4,(a0)		;en OR
        lea     30(a0),a0		;Ligne suivante
        dbra.w  d7,loop_secure	;Boucle
        lea     pos(pc),a0
        move.l  (a0)+,d1
        move.l  (a0),d0
        bsr     affno		;Surlignage
        movem.l (a7)+,d0
        rts
        
get_pers:
        movem.l d0-d1/a0,-(a7)
        lea     pos(pc),a0
        move.l  (a0)+,d1
        move.l  (a0)+,d0
        bsr     get_tab_d0_d1_in_d5
        movem.l (a7)+,d0-d1/a0
        rts

;*************************************
;*** Met la valeur (d0,d1) dans d5 ***
;*************************************
get_tab_d0_d1_in_d5:    ;d0.l=y d1.l=x
        movem.l d0-d2/a0,-(a7)
        move.l  hor2,d2
        mulu    d2,d0			;d0 * nb de colonnes
        add.l   d1,d0			;+ n de la colonne
        lea     tab(pc),a0			;a0 pointe sur le tableau
        adda.l  d0,a0			;a0 pointe sur le curseur
        move.b  (a0),d5			;chargement de la valeur en d5
        movem.l (a7)+,d0-d2/a0
        rts

;****************************************
;*** Met la valeur de d5 dans (d0,d1) ***
;****************************************
put_d5_in_tab_d0_d1:    ;d0.l=y d1.l=x
        movem.l d0-d2/a0,-(a7)
        move.l  hor2,d2			;Meme travail
        mulu    d2,d0

        add.l   d1,d0
        lea     tab(pc),a0
        adda.l  d0,a0
        move.b  d5,(a0)			;Cahrgement de d5
        movem.l (a7)+,d0-d2/a0
        rts

aff2:
        movem.l d7/a0-a1,-(a7)
        move.l  a2,a0
        bsr     aff0
        movem.l (a7)+,d7/a0-a1
        rts

;***********************************
;*** Dcouvre la case en (d0,d1) ***
;***********************************
doenter:
        movem.l d0-d3/d6/a0,-(a7)
        bsr     get_tab_d0_d1_in_d5
        cmp.b   #2,d5
        bge     finenter	;Si la case est >= 2 -> pas de domplications
        move.b  #2,d5			;Nveau contenu
        bsr     put_d5_in_tab_d0_d1	;Chargement
        lea     nbreste(pc),a0		;Compteur interne
        sub.l   #1,(a0)			;-1
        bsr     compte			;Nb de mines autour?
        bsr     affno			;Surlignage -> normal
        bsr     affnum			;Affichage
        bsr     affno			;Surlignage -> surlign
        cmp.b   #0,d4			;nb de mines autour = 0?
        bne     finenter			;sinon fin
        move.l  d0,d2
        add.l   #1,d2
        cmp.l   vert2,d2
        beq     autour1	;limite  droite
        add.l   #1,d2
autour1:
        cmp.b   #0,d0
        beq     autour2	;limite  gauche
        sub.l   #1,d0
autour2:
        move.l  d0,d3
        move.l  d1,d6	;limite en bas
        add.l   #1,d6
        cmp.l   hor2,d6
        beq     autour3
        add.l   #1,d6
autour3:
        cmp.b   #0,d1	;limite en haut
        beq     loop_autour1
        sub.l   #1,d1
loop_autour1:
        move.l  d3,d0
loop_autour2:
        bsr     get_tab_d0_d1_in_d5
        bsr     doenter
        add.l   #1,d0
        cmp.l   d0,d2		;On dcouvre autour
        bne     loop_autour2
        add.l   #1,d1
        cmp.l   d1,d6
        bne     loop_autour1
finenter:
        movem.l (a7)+,d0-d3/d6/a0
        rts

;********************************************************
;*** Compte autour de (d0,d1) le nombre de mines rel ***
;********************************************************
compte:
        movem.l d0-d3/d5-d7,-(a7)
        clr.l   d4
        move.l  d0,d2
        add.l   #1,d2
        cmp.l   vert2,d2
        beq     compte1
        add.l   #1,d2
compte1:				;meme travail
        cmp.b   #0,d0
        beq     compte2
        sub.l   #1,d0
compte2:
        move.l  d0,d3
        move.l  d1,d6
        add.l   #1,d6
        cmp.l   hor2,d6
        beq     compte3
        add.l   #1,d6
compte3:
        cmp.b   #0,d1
        beq     loop_compte1
        sub.l   #1,d1
loop_compte1:
        move.l  d3,d0
loop_compte2:
        bsr     get_tab_d0_d1_in_d5
        and.b   #1,d5			;C'est ici qu'il faut changer le test de bit
        add.b   d5,d4
        add.l   #1,d0
        cmp.l   d0,d2
        bne     loop_compte2
        add.l   #1,d1
        cmp.l   d1,d6
        bne     loop_compte1
        movem.l (a7)+,d0-d3/d5-d7
        rts

;***************************************
;*** Affiche un nombre d4 en (d0,d1) ***
;***************************************
affnum:
        movem.l d0-d1/d4,-(a7)
        lsl.l   #1,d0
        move.l  d0,d2
        lsl.l   #4,d0
        sub.l   d2,d0
        lsl.l   #3,d0
        add.l   d1,d0
        move.l  graphlib::plane0,a0
        move.l  graphlib::plane1,a1
        adda.l  d0,a0
        adda.l  d0,a1
        move.w  #7,d0
        lea     nul(pc),a2
        lsl.l   #3,d4
        lea     nul(pc),a4
        adda.l  d4,a4
loop_affnum:
        move.b  (a4)+,(a0)
        move.b  (a2)+,(a1)
        lea     30(a1),a1
        lea     30(a0),a0
        dbra.w  d0,loop_affnum
        movem.l (a7)+,d0-d1/d4
        rts
        
;*******************
set_font:
        movem.l d0-d2,-(a7)
        move.w  d0,-(a7)
        jsr     doorsos::FontSetSys
        move.w  (a7)+,d0
        movem.l (a7)+,d0-d2
        rts

;*******************
big_pause:
	movem.l d6/d7,-(a7)
	move.w	#500,d7
big_pause_1:
	move.w	#500,d6
big_pause_2:
	dbra	d6,big_pause_2
	dbra	d7,big_pause_1
	movem.l (a7)+,d6/d7
	rts

;*******************
small_pause:
	movem.l d6/d7,-(a7)
	move.w	#500,d7
small_pause_1:
	move.w	#50,d6
small_pause_2:
	dbra	d6,small_pause_2
	dbra	d7,small_pause_1
	movem.l (a7)+,d6/d7
	rts

;*******************
clr_scr:
        move.l  graphlib::plane0,a1     ;adress of the 1st bitplane
        jsr     graphlib::clr_scr
        move.l  graphlib::plane1,a1        ;adress of the 2nd bitplane
        jsr     graphlib::clr_scr        ;clears the second bitplane
        rts

;*******************
pass_to_4:
        jsr     graphlib::gray4
        rts

;surl:
;        movem.l d4/d5/a0,-(a7)
;        move.l  d5,d4
;        lsl.l   #3,d4
;        add.l   d5,d4
;        move.l  d4,d5
;        lsl.l   #1,d5
;        lsl.l   #5,d4
;        sub.l   d5,d4
;        lea     LCD_MEM+39*30,a0
;        adda.l  d4,a0
;        move.w  #30*9-1,d4
;loop_surl1:
;        not.b   (a0)+
;        dbra.w  d4,loop_surl1
;        movem.l (a7)+,d4/d5/a0
;        rts

;*************
;* Variables *
;*************
tab     dcb.b   240,0

;***********
;* Sprites *
;***********

flag:
        dc.b    %00000000
        dc.b    %00010000
        dc.b    %00110000
        dc.b    %01110000
        dc.b    %00010000
        dc.b    %01111100
        dc.b    %00000000
        dc.b    %00000000

notsprite:
        dc.b    %10000011
        dc.b    %01000111
        dc.b    %00101011
        dc.b    %00010011
        dc.b    %00101011
        dc.b    %01000111
        dc.b    %11111111
        dc.b    %11111111
        dc.b    %00000000
        dc.b    %00000001
        dc.b    %00000001
        dc.b    %00000001
        dc.b    %00000001
        dc.b    %00000001
        dc.b    %00000001
        dc.b    %01111111

bombe:
        dc.b    $0
        dc.b    $5A
        dc.b    $3C
        dc.b    $6E
        dc.b    $7E
        dc.b    $3C
        dc.b    $5A
        dc.b    $0
        dc.b    $1
        dc.b    $1
        dc.b    $3
        dc.b    $1
        dc.b    $1
        dc.b    $3
        dc.b    $25
        dc.b    $FF

bloc:
        dc.b    $3
        dc.b    $7
        dc.b    $7
        dc.b    $7
        dc.b    $7
        dc.b    $7F
        dc.b    $FF
        dc.b    $FF
        dc.b    $3
        dc.b    $7
        dc.b    $7
        dc.b    $7
        dc.b    $7
        dc.b    $7F
        dc.b    $FF
        dc.b    $FF

nul:
        dc.b    $1
        dc.b    $1
        dc.b    $1
        dc.b    $1
        dc.b    $1
        dc.b    $1
        dc.b    $1
        dc.b    $FF

        dc.b    $1 ; 1
        dc.b    $11
        dc.b    $31
        dc.b    $11
        dc.b    $11
        dc.b    $39
        dc.b    $1
        dc.b    $FF

        dc.b    $1 ; 2
        dc.b    $31
        dc.b    $9
        dc.b    $11
        dc.b    $21
        dc.b    $39
        dc.b    $1
        dc.b    $FF

        dc.b    $1 ; 3
        dc.b    $39
        dc.b    $9
        dc.b    $11
        dc.b    $9
        dc.b    $31
        dc.b    $1
        dc.b    $FF

        dc.b    $1
        dc.b    $29
        dc.b    $29
        dc.b    $39
        dc.b    $9
        dc.b    $9
        dc.b    $1
        dc.b    $FF

        dc.b    $1
        dc.b    $39
        dc.b    $21
        dc.b    $31
        dc.b    $9
        dc.b    $31
        dc.b    $1
        dc.b    $FF


        dc.b    $1
        dc.b    $19
        dc.b    $21
        dc.b    $39
        dc.b    $29
        dc.b    $39
        dc.b    $1
        dc.b    $FF

        dc.b    $1
        dc.b    $39
        dc.b    $9
        dc.b    $11
        dc.b    $21
        dc.b    $21
        dc.b    $1
        dc.b    $FF

        dc.b    $1
        dc.b    $39
        dc.b    $29
        dc.b    $39
        dc.b    $29
        dc.b    $39
        dc.b    $1
        dc.b    $FF

deathstr dc.b   "BOUM!!! Lost!   ",0
winstr  dc.b    "You win!           ",0
misen   dc.b    "MineHunt_s by Paxal",0
strmine dc.b    "Mines   -  +",0
strvert dc.b    "High    ",19,"  ",20,0
strhor  dc.b    "Width   ",17,"  ",18,0
	 dc.w	  0
char1   dc.b    0
char2   dc.b    0,0

pos     dc.l    0,0

titre
        include gif2.asm

contrast dc.b	0
nbmr_aff dc.l	  0
nb2     dc.l    45
nb      dc.l    44
nbreste dc.l    0
nbsec   dc.l    0
newpart dc.b    0
vert    dc.l    11
vert2   dc.l    12
hor     dc.l    19
hor2    dc.l    20

_comment        dc.b    "Dmineur",0
        end
